uniform vec4	uniColor;	//	premultiplied alpha

in mat4			atrModelViewProjectionMatrix;
in vec3			atrDiffuseEvaluator,
				atrSpecularEvaluator;
in vec3			atrPosition;
in vec3			atrNormal;

out vec4		varColor;	//	premultiplied alpha


void main()
{
	float	tmpDiffuseFactor,
			tmpSpecularFactor;

	gl_Position = atrModelViewProjectionMatrix * vec4(atrPosition, 1.0);

	tmpDiffuseFactor	= 0.25 + 0.75 * max(0.0, dot(atrDiffuseEvaluator, atrNormal));
	tmpSpecularFactor	= 0.25 * pow(max(0.0, dot(atrSpecularEvaluator, atrNormal)), 64.0);

	varColor = vec4(tmpDiffuseFactor * uniColor.r  +  tmpSpecularFactor,
					tmpDiffuseFactor * uniColor.g  +  tmpSpecularFactor,
					tmpDiffuseFactor * uniColor.b  +  tmpSpecularFactor,
									   uniColor.a  +  tmpSpecularFactor);
}
